unit ExpSample;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, ExtCtrls, Printers, expdc_lib, expdc_def;

type
	TmainFrm = class(TForm)
	Panel1: TPanel;
	SpeedButton1: TSpeedButton;
	SpeedButton2: TSpeedButton;
	procedure FormPaint(Sender: TObject);
	procedure ExportDC(Sender: TObject);
	procedure OnBtnPrint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
private
	pagesize: TPoint;
	pages: integer;
	pdfopts: TPdfOptions;

	procedure Draw(dc: TCanvas; page: integer);
	procedure Print(dc: TCanvas; bExp: boolean);

public
end;

var
  mainFrm: TmainFrm;

const
	DATADIR	= '..\\..\\data\\';

implementation

{$R *.DFM}

procedure TmainFrm.FormCreate(Sender: TObject);
var d: array [0..MAX_PATH] of char;
l: integer;
begin
	GetModuleFileName(HInstance, d, SizeOf(d));
	l := strlen(d);
	while l > 0 do begin
		if d[l] = '\' then begin
			d[l] := char(0);
			break;
		end;
		dec(l);
	end;
	SetCurrentDirectoryA(d);

	pagesize.x := 2100; pagesize.y := 1490;
	pages := 2;
	ExpDCGetPDFOptions(pdfopts);
end;

procedure TmainFrm.FormPaint(Sender: TObject);
var r: TRect;
begin
	r := Rect(0, 0, pagesize.x, -pagesize.y);
	mainFrm.Canvas.Brush.Color := RGB(255, 255, 255);
	SetMapMode(mainFrm.Canvas.Handle, MM_LOMETRIC);
	SetViewportOrgEx(mainFrm.Canvas.Handle, 50, 50, nil);
	mainFrm.Canvas.FillRect(r);
	Draw(mainFrm.Canvas, 0);
end;

procedure TmainFrm.Draw(dc: TCanvas; page: integer);
var lb: TLOGBRUSH; hBmp: HBITMAP; hBr, hBrOld: HBRUSH; bmp: TBitmap;
i, y, d, d05: integer; s: string; buf: array [0..256] of char;
begin
	hBrOld := 0;
	hBr := 0;
	SetMapMode(dc.Handle, MM_LOMETRIC);

	dc.Font.Name := 'Arial';
	dc.Font.Height := 20;
	dc.Font.Style := [];
	s := Format('Page %d', [page + 1]);
	dc.TextOut(100, -50, s);

	if(page = 0) then begin
		dc.Pen.Style := psSolid;
		dc.Pen.Width := 5;
		dc.Pen.Color := RGB(150, 60, 10);

		dc.MoveTo(100, -230);
		dc.LineTo(pagesize.x - 100, -230);

		s := Format('%s%s', [DATADIR, 'bg1.bmp']);
		hBmp := LoadImage(0, PChar(s), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
		if(hBmp <> 0) then begin
			lb.lbColor := DIB_RGB_COLORS;
			lb.lbStyle := BS_PATTERN;
			lb.lbHatch := hBmp;

			hBr := CreateBrushIndirect(lb);
			hBrOld := SelectObject(dc.Handle, hBr);

			DeleteObject(hBmp);
		end;

		dc.Font.Name := 'Arial';
		dc.Font.Height := 130;
		dc.Font.Style := [fsBold];
		SetBkMode(dc.Handle, TRANSPARENT);
		BeginPath(dc.Handle);
		dc.TextOut(400, -80, 'Simply export DC to PDF');
		EndPath(dc.Handle);
		FillPath(dc.Handle);

		SelectObject(dc.Handle, hBrOld);
		DeleteObject(hBr);

		y := -500;
		for i := 0 to 2 do begin
			dc.Font.Height := 30;

			case i of
				0: dc.Font.Name := 'Arial';
				1: dc.Font.Name := 'Courier New';
				2: dc.Font.Name := 'Comic Sans MS';
			end;

			GetTextFace(dc.Handle, 255, buf);
			dc.Font.Style := [];
			dc.TextOut(100, y + -(i * 50), buf);
			dc.Font.Style := [fsBold];
			dc.TextOut(300, y + -(i * 50), 'Bold');
			dc.Font.Style := [fsItalic];
			dc.TextOut(400, y + -(i * 50), 'Italic');
			dc.Font.Style := [fsBold, fsItalic];
			dc.TextOut(500, y + -(i * 50), 'BoldItalic');
			dc.Font.Style := [fsStrikeout, fsUnderline];
			dc.TextOut(650, y + -(i * 50), 'strikeout and underline');
		end;

		y := y - 500;
		d := 600;
		d05 := Round(d / 2);

		dc.Pen.Width := 2;
		dc.Pen.Color := RGB(0, 0, 0);

		bmp := TBitmap.Create;
		s := Format('%s%s', [DATADIR, 'bg1.bmp']);
		bmp.LoadFromFile(PChar(s));
		dc.Brush.Bitmap := bmp;

		BeginPath(dc.Handle);
		dc.MoveTo(400, y);
		dc.LineTo(100, y);
		ArcTo(dc.Handle, 400 - d05, y + d05, 400 + d05, y - d05, 400 - d05, y, 400 - 200, y - 100);
		dc.LineTo(400, y);
		EndPath(dc.Handle);
		StrokeAndFillPath(dc.Handle);

		dc.Brush.Bitmap := nil;
		bmp.Free;
		bmp := TBitmap.Create;
 		s := Format('%s%s', [DATADIR, 'ptrn2-32x32.bmp']);
		bmp.LoadFromFile(PChar(s));
		dc.Brush.Bitmap := bmp;
		BeginPath(dc.Handle);
		ArcTo(dc.Handle, 400 - d05, y + d05, 400 + d05, y - d05, 400 - 200, y - 100, 400, y - 400);
		dc.LineTo(400, y);
		EndPath(dc.Handle);
		StrokeAndFillPath(dc.Handle);

		dc.Brush.Bitmap := nil;
		bmp.Free;
		bmp := TBitmap.Create;
		s := Format('%s%s', [DATADIR, 'ptrn3-32x32.bmp']);
		bmp.LoadFromFile(PChar(s));
		dc.Brush.Bitmap := bmp;
		BeginPath(dc.Handle);
		ArcTo(dc.Handle, 400 - d05, y + d05, 400 + d05, y - d05, 400, y - 400, 700, y - 400);
		dc.LineTo(400, y);
		EndPath(dc.Handle);
		StrokeAndFillPath(dc.Handle);

		dc.Brush.Bitmap := nil;
		dc.Brush.Color := RGB(200, 200, 200);
		BeginPath(dc.Handle);
		ArcTo(dc.Handle, 400 - d05, y + d05, 400 + d05, y - d05, 700, y - 400, 300, y + 400);
		dc.LineTo(400, y);
		EndPath(dc.Handle);
		StrokeAndFillPath(dc.Handle);

 		dc.Brush.Color := RGB(230, 230, 230);
		BeginPath(dc.Handle);
		ArcTo(dc.Handle, 400 - d05, y + d05, 400 + d05, y - d05, 300, y + 400, 100, y);
		dc.LineTo(400, y);
		EndPath(dc.Handle);
		StrokeAndFillPath(dc.Handle);

		y := y + 300;
		dc.Pen.Width := 2;
		dc.Pen.Color := RGB(200, 200, 200);
		dc.MoveTo(1000, y);
		dc.LineTo(1000, y - 600);
		dc.LineTo(1700, y - 600);
		for i := 0 to 13 do begin
			dc.MoveTo(1050 + i * 50, y - 600);
			dc.LineTo(1050 + i * 50, y - 610);
		end;
		for i := 0 to 12 do begin
			dc.MoveTo(990, y - 550 + i * 50);
			dc.LineTo(1000, y - 550 + i * 50);
		end;

		bmp.Free;
		bmp := TBitmap.Create;
		s := Format('%s%s', [DATADIR, 'ptrn1-8x8.bmp']);
		bmp.LoadFromFile(PChar(s));
		dc.Brush.Bitmap := bmp;

		dc.FillRect(Rect(1050, y - 100, 1150, y - 600));

		dc.Brush.Bitmap := nil;
		bmp.Free;
		bmp := TBitmap.Create;
		s := Format('%s%s', [DATADIR, 'bg1.bmp']);
		bmp.LoadFromFile(PChar(s));
		dc.Brush.Bitmap := bmp;

		dc.FillRect(Rect(1200, y - 200, 1300, y - 600));

		dc.Brush.Bitmap := nil;
		bmp.Free;
		bmp := TBitmap.Create;
		s := Format('%s%s', [DATADIR, 'ptrn2-8x8.bmp']);
		bmp.LoadFromFile(PChar(s));
		dc.Brush.Bitmap := bmp;

		dc.FillRect(Rect(1350, y - 500, 1450, y - 600));
 
		dc.Brush.Bitmap := nil;
		bmp.Free;
		bmp := TBitmap.Create;
		s := Format('%s%s', [DATADIR, 'ptrn3-32x32.bmp']);
		bmp.LoadFromFile(PChar(s));
		dc.Brush.Bitmap := bmp;

		dc.FillRect(Rect(1500, y - 50, 1600, y - 600));

		dc.Brush.Bitmap := nil;
		bmp.Free;
	end else if page = 1 then begin
		dc.Font.Height := 50;
		dc.TextOut(100, -500, 'The content of the second page...');
	end;

end;

procedure TmainFrm.Print(dc: TCanvas; bExp: boolean);
var i: integer;
begin

	if(bExp) then begin
		ExpDCStartDoc();
	end else
		Printer.BeginDoc;

	for i := 0 to pages - 1 do begin
		if(bExp) then
			ExpDCStartPage;

		Draw(dc, i);

		if(bExp) then
			ExpDCEndPage
		else
			if(i < pages - 1) then Printer.NewPage;
	end;

	if(bExp) then
		ExpDCEndDoc
	else
		Printer.EndDoc;
end;


procedure TmainFrm.ExportDC(Sender: TObject);
var h_DC: HDC; dc: TCanvas; r: TRect;
err: integer;
errinfo: PChar;
begin
	ExpDCSetPDFInfo(nil, nil, 'ExpSample', '1.0', nil, nil);	
	ExpDCSetPDFOptions(pdfopts);

	dc := TCanvas.Create;

	ExpDCUseExceptions(true);
	try
		r.left := 0; r.top := 0; r.right := pagesize.x; r.bottom := pagesize.y;
		h_DC := ExpDCCreate(@r, nil);
		dc.Handle := h_DC;
		err := ExpDCSetFileName(PChar(Format('%s%s', [ExtractFilePath(Application.ExeName), 'example.pdf'])), true);
		if(err = 0) then
			Print(dc, true)
		else
			MessageBox(0, PChar(Format('Open File: %d', [err])), '', IDOK);
	except
		err := ExpDCGetError(errinfo);
		MessageBox(0, PChar(Format('Error: %d (%s)', [err, errinfo])), '', IDOK);
	end;

	dc.Destroy;
	ExpDCRelease();

end;

procedure TmainFrm.OnBtnPrint(Sender: TObject);
begin
	Print(Printer.Canvas, false);
end;


end.
