
#include "stdafx.h"
#include "ExpSample.h"
#include "DlgExp.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



CDlgExp::CDlgExp(s_pdfoptions& opts, CString expfile, CWnd* pParent)
	: CDialog(CDlgExp::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDlgExp)
	//}}AFX_DATA_INIT

	m_opts = opts;
	m_expfile = expfile;
}


void CDlgExp::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDlgExp)
	DDX_Control(pDX, IDC_CBSTDFNTSUBST, m_cbStdFntSubst);
	DDX_Control(pDX, IDC_CBFLTPG, m_cbFltPg);
	DDX_Control(pDX, IDC_CBFLTCOLIMG, m_cbFltColImg);
	DDX_Control(pDX, IDC_CBFLTFNT, m_cbFltFnt);
	DDX_Control(pDX, IDC_EDFILE, m_edFile);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDlgExp, CDialog)
	//{{AFX_MSG_MAP(CDlgExp)
	ON_BN_CLICKED(IDC_BTNSELFILE, OnBtnselfile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


BOOL CDlgExp::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_edFile.SetWindowText(m_expfile);

	m_cbStdFntSubst.SetCheck(m_opts.standardFontSubstitution);

	m_cbFltPg.AddString(_T("none"));
	m_cbFltPg.AddString(_T("Flate"));
	m_cbFltPg.AddString(_T("LZW"));
	m_cbFltPg.SetItemData(0, fp_none);
	m_cbFltPg.SetItemData(1, fp_flate);
	m_cbFltPg.SetItemData(2, fp_lzw);
	switch(m_opts.filterPages)
	{
	case fp_none: m_cbFltPg.SetCurSel(0); break;
	case fp_flate: m_cbFltPg.SetCurSel(1); break;
	case fp_lzw: m_cbFltPg.SetCurSel(2); break;
	}

	m_cbFltFnt.AddString(_T("none"));
	m_cbFltFnt.AddString(_T("Flate"));
	m_cbFltFnt.AddString(_T("LZW"));
	m_cbFltFnt.SetItemData(0, ff_none);
	m_cbFltFnt.SetItemData(1, ff_flate);
	m_cbFltFnt.SetItemData(2, ff_lzw);
	switch(m_opts.filterFonts)
	{
	case ff_none: m_cbFltFnt.SetCurSel(0); break;
	case ff_flate: m_cbFltFnt.SetCurSel(1); break;
	case ff_lzw: m_cbFltFnt.SetCurSel(2); break;
	}

	m_cbFltColImg.AddString(_T("none"));
	m_cbFltColImg.AddString(_T("Flate"));
	m_cbFltColImg.AddString(_T("DCT"));
	m_cbFltColImg.SetItemData(0, fci_none);
	m_cbFltColImg.SetItemData(1, fci_flate);
	m_cbFltColImg.SetItemData(2, fci_dct);
	switch(m_opts.filterColorImages)
	{
	case fci_none: m_cbFltColImg.SetCurSel(0); break;
	case fci_flate: m_cbFltColImg.SetCurSel(1); break;
	case fci_dct: m_cbFltColImg.SetCurSel(2); break;
	}
	
	return TRUE;
}

void CDlgExp::OnBtnselfile() 
{
	CFileDialog dlg(TRUE, NULL, NULL, 0, _T("pdf|*.pdf||"));
	if(dlg.DoModal() == IDOK)
	{
		m_edFile.SetWindowText(dlg.m_ofn.lpstrFile);
	}
}

void CDlgExp::OnOK() 
{
	m_edFile.GetWindowText(m_expfile);
	m_opts.standardFontSubstitution = m_cbStdFntSubst.GetCheck() != 0;
	m_opts.filterPages = (e_fltpage)m_cbFltPg.GetItemData(m_cbFltPg.GetCurSel());
	m_opts.filterFonts = (e_fltfont)m_cbFltFnt.GetItemData(m_cbFltFnt.GetCurSel());
	m_opts.filterColorImages = (e_fltcolimg)m_cbFltColImg.GetItemData(m_cbFltColImg.GetCurSel());
	
	CDialog::OnOK();
}
