
#ifndef __EXPLIB_DEF_H__
#define __EXPLIB_DEF_H__

#pragma warning (disable : 4786)
#include <string>

enum e_expmode
{
	em_none = 0,
	em_pdf = 1
};

enum e_corefont
{
	cf_times,
	cf_helvetica,
	cf_courier,
	cf_symbol,
	cf_zapfdingbats
};

enum e_fltpage
{
	fp_none,
	fp_lzw,
	fp_flate
};

enum e_fltfont
{
	ff_none,
	ff_lzw,
	ff_flate
};

enum e_fltcolimg
{
	fci_none,
	fci_dct,
	fci_flate
};

struct s_pdfoptions
{
	e_fltpage filterPages;
	e_fltfont filterFonts;
	e_fltcolimg filterColorImages;
	bool standardFontSubstitution;
};

#define EEXPDC_UNKNOWN			1
#define EEXPDC_NOTINITIALIZED	2
#define EEXPDC_INSUFFMEMORY		3
#define EEXPDC_FILEEXISTS		1000
#define EEXPDC_FILEPERMISSION	1001
#define EEXPDC_FILEUNKNOWN		1002
#define EEXPDC_NOSTARTDOC		1003
#define EEXPDC_NOSTARTPAGE		1004


#ifdef _USE_EXPEXCEPTIONS_

class CExpDCException
{
public:
	CExpDCException(long e, const char* info) 
	{ 
		m_error = e;
		if(info != NULL)
			m_errinfo = info;
	}
	~CExpDCException() {}

	long GetError() { return m_error; }
	const char* GetErrInfo() { return m_errinfo.c_str(); }

protected:
	long m_error;
	std::string m_errinfo;

};

#endif


#endif

