
#ifndef __EXPLIB_H__
#define __EXPLIB_H__

#include "expdc_def.h"

#ifdef __cplusplus
extern "C" {
#endif

#ifndef EXPDLL_API
#define EXPDLL_API __declspec(dllimport)
#endif

EXPDLL_API void ExpDCUseExceptions(bool bUse);
EXPDLL_API long ExpDCGetError(const char** info);
EXPDLL_API HDC ExpDCCreate(const RECT* bounds, const char* licensekey);
EXPDLL_API void ExpDCRelease();
EXPDLL_API const char* ExpDCGetData(long* sz);
EXPDLL_API long ExpDCSetFileName(const char* filename, bool bOverwrite);
EXPDLL_API long ExpDCSetMode(e_expmode m);
EXPDLL_API long ExpDCGetPDFOptions(s_pdfoptions* opts);
EXPDLL_API long ExpDCSetPDFOptions(s_pdfoptions opts);
EXPDLL_API long ExpDCSetPDFInfo(tm* creationDate, const char* author, const char* creator, const char* title, const char* subject, const char* keywords);
EXPDLL_API long ExpDCSetFontSubstitution(e_corefont corefont, const char* fonts);

EXPDLL_API int ExpDCStartDoc();
EXPDLL_API int ExpDCEndDoc();
EXPDLL_API int ExpDCStartPage();
EXPDLL_API int ExpDCEndPage();

#ifdef __cplusplus
}
#endif


#ifdef _USE_EXPCLASS_
class CExpDC : public CDC
{
public:
	CExpDC(const CRect& bounds, const char* licensekey)
	{
		HDC hDC = ExpDCCreate(bounds, licensekey);
		Attach(hDC);
	}
	virtual ~CExpDC() { Detach(); ExpDCRelease(); }

public:


	int StartDoc(LPDOCINFO lpDocInfo) { return ExpDCStartDoc(); }
	int StartDoc(LPCTSTR lpszDocName) {	return ExpDCStartDoc(); }
	int EndDoc() { return ExpDCEndDoc(); }
	int StartPage() { return ExpDCStartPage(); }
	int EndPage() { return ExpDCEndPage(); }
};

#endif

#endif

